\usepackage{tikz}
\usepackage{gnuplot-lua-tikz}

\usetikzlibrary{shapes,arrows,decorations}
\usetikzlibrary{decorations.text,decorations.pathreplacing}

% tikz setup
\tikzstyle{board} = [rectangle, draw, rounded corners,
                     font=\footnotesize, fill=gray!20,
                     very thick, draw=gray,
                     minimum height=3em, minimum width=3em,
                     node distance=2em]
\tikzstyle{cord} = [-hooks reversed, very thick, draw=black]
\tikzstyle{sboard} = [board, yslant=0.5, xslant=-1,]
\tikzstyle{fboard} = [yslant=0.5, xslant=-1,
                      minimum height=2.8em, minimum width=2.8em,]
\tikzstyle{mut-op} = [->, black, thick, bend right=90, distance=0.75em]
\tikzstyle{sub-pop} = [font=\footnotesize]

\def\board(#1,#2){
  % processor
  \node [rectangle, draw, very thick, fill=black!80, draw=black!80,
         scale=0.75, yslant=0.5, xslant=-1]
        at (#1+0.125,#2+0.0675) {};
  % button
  \node [rectangle, draw, fill=white!80,
         scale=0.25, yslant=0.5, xslant=-1]
        at (#1-0.2,#2) {};
  % other stuff
  \node [rectangle, draw, fill=black!80, draw=black!80,
         scale=0.16, yslant=0.5, xslant=-1,
         minimum width=3em, minimum height=1em]
        at (#1,#2-0.16) {};
  % connectors
  \foreach \xb in {0.425,-0.425} {
    \node [rectangle, draw, very thick, fill=black!80, draw=black!80,
           minimum width=1em, minimum height=6em,scale=0.125,
          yslant=0.5, xslant=-1]
          at (#1+\xb,#2) {};
    \foreach \t in {-0.15,-0.1,...,0.15}{
      \draw [color=orange] (#1+\xb,#2+\t) to (#1+\xb*0.85,#2+\t); }
  }
  \foreach \yb in {0.425,-0.425} {
    \node [rectangle, draw, very thick, fill=black!80, draw=black!80,
           minimum height=1em, minimum width=6em,scale=0.125,
          yslant=0.5, xslant=-1]
          at (#1,#2+\yb) {};
    \foreach \t in {-0.15,-0.1,...,0.15}{
      \draw [color=orange] (#1+\t,#2+\yb) to (#1+\t,#2+\yb*0.85); }
  }
}
\def\flatboard(#1,#2){
  % processor
  \node [rectangle, draw, very thick, fill=black!80, draw=black!80, scale=0.75]
        at (#1+0.125,#2+0.0675) {};
  % button
  \node [rectangle, draw, fill=white!80, scale=0.25]
        at (#1-0.2,#2) {};
  % other stuff
  \node [rectangle, draw, fill=black!80, draw=black!80,
         scale=0.16,
         minimum width=3em, minimum height=1em]
        at (#1,#2-0.16) {};
  % connectors
  \foreach \xb in {0.425,-0.425} {
    \node [rectangle, draw, very thick, fill=black!80, draw=black!80,
           minimum width=1em, minimum height=6em,scale=0.125]
          at (#1+\xb,#2) {};
    \foreach \t in {-0.15,-0.1,...,0.15}{
      \draw [color=orange] (#1+\xb,#2+\t) to (#1+\xb*0.85,#2+\t); }
  }
  \foreach \yb in {0.425,-0.425} {
    \node [rectangle, draw, very thick, fill=black!80, draw=black!80,
           minimum height=1em, minimum width=6em,scale=0.125]
          at (#1,#2+\yb) {};
    \foreach \t in {-0.15,-0.1,...,0.15}{
      \draw [color=orange] (#1+\t,#2+\yb) to (#1+\t,#2+\yb*0.85); }
  }
}
\def\bflatboard(#1,#2){
  % processor
  \node [rectangle, draw, very thick, fill=black!80, draw=black!80, scale=3]
        at (#1+0.125,#2+0.0675) {};
  % button
  \node [rectangle, draw, fill=white!80, scale=0.75]
        at (#1-0.2,#2) {};
  % other stuff
  \node [rectangle, draw, fill=black!80, draw=black!80,
         scale=0.64,
         minimum width=3em, minimum height=1em]
        at (#1,#2-0.16) {};
  % connectors
  \foreach \xb in {0.425,-0.425} {
    \node [rectangle, draw, very thick, fill=black!80, draw=black!80,
           minimum width=1em, minimum height=6em,scale=0.8]
          at (#1+\xb,#2) {};
    \foreach \t in {-0.075,-0.05,...,0.075}{
      \draw [very thick, color=orange] (#1+\xb,#2+\t) to (#1+\xb*0.9,#2+\t); }
  }
  \foreach \yb in {0.425,-0.425} {
    \node [rectangle, draw, very thick, fill=black!80, draw=black!80,
           minimum height=1em, minimum width=6em,scale=0.8]
          at (#1,#2+\yb) {};
    \foreach \t in {-0.075,-0.05,...,0.075}{
      \draw [very thick, color=orange] (#1+\t,#2+\yb) to (#1+\t,#2+\yb*0.9); }
  }
}
\def\individual(#1,#2,#3){
  {\footnotesize
    \path [decorate, decoration={text along path,text={#3}}]
          (#1-0.75,#2) to (#1+0.75,#2);
  }
}
